Index: Makefile
===================================================================
--- Makefile	(revision f53a4d29acc13d296285ecd9b0a986c73a2c0efb)
+++ Makefile	(revision d38348d6fa05d814372b4af29ec82c9928ff5be9)
@@ -257,4 +257,5 @@
 	classes/DelphesClasses.h \
 	classes/DelphesFactory.h \
+	classes/DelphesLHEFReader.h \
 	external/ExRootAnalysis/ExRootTreeWriter.h \
 	external/ExRootAnalysis/ExRootTreeBranch.h \
@@ -321,4 +322,5 @@
 	modules/UniqueObjectFinder.h \
 	modules/TrackCountingBTagging.h \
+	modules/BTaggingCMS.h \
 	modules/BTagging.h \
 	modules/TauTagging.h \
@@ -337,4 +339,6 @@
 	modules/Weighter.h \
 	modules/Hector.h \
+	modules/RunPUPPI.h \
+	modules/JetFlavorAssociation.h \
 	modules/ExampleModule.h
 ModulesDict$(PcmSuf): \
@@ -521,4 +525,7 @@
 tmp/external/Hector/H_VerticalQuadrupole.$(ObjSuf): \
 	external/Hector/H_VerticalQuadrupole.$(SrcSuf)
+tmp/external/PUPPI/puppiCleanContainer.$(ObjSuf): \
+	external/PUPPI/puppiCleanContainer.$(SrcSuf) \
+	external/fastjet/Selector.hh
 tmp/modules/AngularSmearing.$(ObjSuf): \
 	modules/AngularSmearing.$(SrcSuf) \
@@ -533,4 +540,13 @@
 	modules/BTagging.$(SrcSuf) \
 	modules/BTagging.h \
+	classes/DelphesClasses.h \
+	classes/DelphesFactory.h \
+	classes/DelphesFormula.h \
+	external/ExRootAnalysis/ExRootResult.h \
+	external/ExRootAnalysis/ExRootFilter.h \
+	external/ExRootAnalysis/ExRootClassifier.h
+tmp/modules/BTaggingCMS.$(ObjSuf): \
+	modules/BTaggingCMS.$(SrcSuf) \
+	modules/BTaggingCMS.h \
 	classes/DelphesClasses.h \
 	classes/DelphesFactory.h \
@@ -652,4 +668,13 @@
 	external/ExRootAnalysis/ExRootFilter.h \
 	external/ExRootAnalysis/ExRootClassifier.h
+tmp/modules/JetFlavorAssociation.$(ObjSuf): \
+	modules/JetFlavorAssociation.$(SrcSuf) \
+	modules/JetFlavorAssociation.h \
+	classes/DelphesClasses.h \
+	classes/DelphesFactory.h \
+	classes/DelphesFormula.h \
+	external/ExRootAnalysis/ExRootResult.h \
+	external/ExRootAnalysis/ExRootFilter.h \
+	external/ExRootAnalysis/ExRootClassifier.h
 tmp/modules/JetPileUpSubtractor.$(ObjSuf): \
 	modules/JetPileUpSubtractor.$(SrcSuf) \
@@ -730,9 +755,19 @@
 	classes/DelphesClasses.h \
 	classes/DelphesFactory.h \
-	classes/DelphesFormula.h \
+	classes/DelphesTF2.h \
 	classes/DelphesPileUpReader.h \
 	external/ExRootAnalysis/ExRootResult.h \
 	external/ExRootAnalysis/ExRootFilter.h \
 	external/ExRootAnalysis/ExRootClassifier.h
+tmp/modules/RunPUPPI.$(ObjSuf): \
+	modules/RunPUPPI.$(SrcSuf) \
+	modules/RunPUPPI.h \
+	external/PUPPI/puppiCleanContainer.hh \
+	external/PUPPI/RecoObj.hh \
+	external/PUPPI/puppiParticle.hh \
+	external/PUPPI/puppiAlgoBin.hh \
+	classes/DelphesClasses.h \
+	classes/DelphesFactory.h \
+	classes/DelphesFormula.h
 tmp/modules/SimpleCalorimeter.$(ObjSuf): \
 	modules/SimpleCalorimeter.$(SrcSuf) \
@@ -869,6 +904,8 @@
 	tmp/external/Hector/H_VerticalKicker.$(ObjSuf) \
 	tmp/external/Hector/H_VerticalQuadrupole.$(ObjSuf) \
+	tmp/external/PUPPI/puppiCleanContainer.$(ObjSuf) \
 	tmp/modules/AngularSmearing.$(ObjSuf) \
 	tmp/modules/BTagging.$(ObjSuf) \
+	tmp/modules/BTaggingCMS.$(ObjSuf) \
 	tmp/modules/Calorimeter.$(ObjSuf) \
 	tmp/modules/Cloner.$(ObjSuf) \
@@ -883,4 +920,5 @@
 	tmp/modules/ImpactParameterSmearing.$(ObjSuf) \
 	tmp/modules/Isolation.$(ObjSuf) \
+	tmp/modules/JetFlavorAssociation.$(ObjSuf) \
 	tmp/modules/JetPileUpSubtractor.$(ObjSuf) \
 	tmp/modules/LeptonDressing.$(ObjSuf) \
@@ -891,4 +929,5 @@
 	tmp/modules/PileUpJetID.$(ObjSuf) \
 	tmp/modules/PileUpMerger.$(ObjSuf) \
+	tmp/modules/RunPUPPI.$(ObjSuf) \
 	tmp/modules/SimpleCalorimeter.$(ObjSuf) \
 	tmp/modules/StatusPidFilter.$(ObjSuf) \
@@ -1080,4 +1119,16 @@
 tmp/external/fastjet/contribs/Nsubjettiness/WinnerTakeAllRecombiner.$(ObjSuf): \
 	external/fastjet/contribs/Nsubjettiness/WinnerTakeAllRecombiner.$(SrcSuf)
+tmp/external/fastjet/contribs/RecursiveTools/ModifiedMassDropTagger.$(ObjSuf): \
+	external/fastjet/contribs/RecursiveTools/ModifiedMassDropTagger.$(SrcSuf) \
+	external/fastjet/JetDefinition.hh \
+	external/fastjet/ClusterSequenceAreaBase.hh
+tmp/external/fastjet/contribs/RecursiveTools/Recluster.$(ObjSuf): \
+	external/fastjet/contribs/RecursiveTools/Recluster.$(SrcSuf)
+tmp/external/fastjet/contribs/RecursiveTools/RecursiveSymmetryCutBase.$(ObjSuf): \
+	external/fastjet/contribs/RecursiveTools/RecursiveSymmetryCutBase.$(SrcSuf) \
+	external/fastjet/JetDefinition.hh \
+	external/fastjet/ClusterSequenceAreaBase.hh
+tmp/external/fastjet/contribs/RecursiveTools/SoftDrop.$(ObjSuf): \
+	external/fastjet/contribs/RecursiveTools/SoftDrop.$(SrcSuf)
 tmp/external/fastjet/contribs/SoftKiller/SoftKiller.$(ObjSuf): \
 	external/fastjet/contribs/SoftKiller/SoftKiller.$(SrcSuf)
@@ -1213,5 +1264,8 @@
 	external/fastjet/contribs/Nsubjettiness/Njettiness.hh \
 	external/fastjet/contribs/Nsubjettiness/NjettinessPlugin.hh \
-	external/fastjet/contribs/Nsubjettiness/WinnerTakeAllRecombiner.hh
+	external/fastjet/contribs/Nsubjettiness/WinnerTakeAllRecombiner.hh \
+	external/fastjet/tools/Filter.hh \
+	external/fastjet/tools/Pruner.hh \
+	external/fastjet/contribs/RecursiveTools/SoftDrop.hh
 tmp/modules/FastJetGridMedianEstimator.$(ObjSuf): \
 	modules/FastJetGridMedianEstimator.$(SrcSuf) \
@@ -1285,4 +1339,8 @@
 	tmp/external/fastjet/contribs/Nsubjettiness/Nsubjettiness.$(ObjSuf) \
 	tmp/external/fastjet/contribs/Nsubjettiness/WinnerTakeAllRecombiner.$(ObjSuf) \
+	tmp/external/fastjet/contribs/RecursiveTools/ModifiedMassDropTagger.$(ObjSuf) \
+	tmp/external/fastjet/contribs/RecursiveTools/Recluster.$(ObjSuf) \
+	tmp/external/fastjet/contribs/RecursiveTools/RecursiveSymmetryCutBase.$(ObjSuf) \
+	tmp/external/fastjet/contribs/RecursiveTools/SoftDrop.$(ObjSuf) \
 	tmp/external/fastjet/contribs/SoftKiller/SoftKiller.$(ObjSuf) \
 	tmp/external/fastjet/plugins/ATLASCone/ATLASConePlugin.$(ObjSuf) \
@@ -1541,13 +1599,13 @@
 	@touch $@
 
-external/fastjet/Selector.hh: \
-	external/fastjet/PseudoJet.hh \
-	external/fastjet/RangeDefinition.hh
-	@touch $@
-
 external/fastjet/internal/Dnn2piCylinder.hh: \
 	external/fastjet/internal/DynamicNearestNeighbours.hh \
 	external/fastjet/internal/DnnPlane.hh \
 	external/fastjet/internal/numconsts.hh
+	@touch $@
+
+external/fastjet/Selector.hh: \
+	external/fastjet/PseudoJet.hh \
+	external/fastjet/RangeDefinition.hh
 	@touch $@
 
@@ -1639,4 +1697,8 @@
 	@touch $@
 
+modules/RunPUPPI.h: \
+	classes/DelphesModule.h
+	@touch $@
+
 modules/Cloner.h: \
 	classes/DelphesModule.h
@@ -1711,4 +1773,9 @@
 	@touch $@
 
+modules/BTaggingCMS.h: \
+	classes/DelphesModule.h \
+	classes/DelphesClasses.h
+	@touch $@
+
 modules/TrackCountingBTagging.h: \
 	classes/DelphesModule.h
@@ -1723,4 +1790,9 @@
 	external/fastjet/ClusterSequenceAreaBase.hh \
 	external/fastjet/ClusterSequenceActiveAreaExplicitGhosts.hh
+	@touch $@
+
+modules/JetFlavorAssociation.h: \
+	classes/DelphesModule.h \
+	classes/DelphesClasses.h
 	@touch $@
 
@@ -1757,4 +1829,12 @@
 	external/fastjet/AreaDefinition.hh \
 	external/fastjet/ClusterSequenceAreaBase.hh
+	@touch $@
+
+external/PUPPI/puppiCleanContainer.hh: \
+	external/PUPPI/RecoObj.hh \
+	external/PUPPI/puppiParticle.hh \
+	external/PUPPI/puppiAlgoBin.hh \
+	external/fastjet/internal/base.hh \
+	external/fastjet/PseudoJet.hh
 	@touch $@
 
Index: classes/ClassesLinkDef.h
===================================================================
--- classes/ClassesLinkDef.h	(revision f53a4d29acc13d296285ecd9b0a986c73a2c0efb)
+++ classes/ClassesLinkDef.h	(revision d38348d6fa05d814372b4af29ec82c9928ff5be9)
@@ -46,4 +46,5 @@
 #pragma link C++ class LHCOEvent+;
 #pragma link C++ class LHEFEvent+;
+#pragma link C++ class LHEFWeight+;
 #pragma link C++ class HepMCEvent+;
 #pragma link C++ class GenParticle+;
Index: classes/DelphesClasses.cc
===================================================================
--- classes/DelphesClasses.cc	(revision f53a4d29acc13d296285ecd9b0a986c73a2c0efb)
+++ classes/DelphesClasses.cc	(revision d38348d6fa05d814372b4af29ec82c9928ff5be9)
@@ -120,6 +120,8 @@
   PID(0), Status(0), M1(-1), M2(-1), D1(-1), D2(-1),
   Charge(0), Mass(0.0),
-  IsPU(0), IsConstituent(0),
-  BTag(0), TauTag(0), Eem(0.0), Ehad(0.0),
+  IsPU(0), IsRecoPU(0), IsConstituent(0),
+  BTag(0), BTagAlgo(0), BTagDefault(0), BTagPhysics(0), BTagNearest2(0), BTagNearest3(0), BTagHeaviest(0), BTagHighestPt(0),
+  FlavorAlgo(0), FlavorDefault(0), FlavorPhysics(0), FlavorNearest2(0), FlavorNearest3(0), FlavorHeaviest(0), FlavorHighestPt(0),
+  TauTag(0), Eem(0.0), Ehad(0.0),
   DeltaEta(0.0), DeltaPhi(0.0),
   Momentum(0.0, 0.0, 0.0, 0.0),
@@ -129,11 +131,22 @@
   NCharged(0),
   NNeutrals(0),
+  NSubJetsTrimmed(0),
+  NSubJetsPruned(0), 
+  NSubJetsSoftDropped(0), 
   Beta(0),
   BetaStar(0),
   MeanSqDeltaR(0),
   PTD(0),
+  Ntimes(-1),
+  IsolationVar(-999),
+  IsolationVarRhoCorr(-999),
+  SumPtCharged(-999),
+  SumPtNeutral(-999),
+  SumPtChargedPU(-999),
+  SumPt(-999),
   fFactory(0),
   fArray(0)
 {
+  int i;
   Edges[0] = 0.0;
   Edges[1] = 0.0;
@@ -150,4 +163,10 @@
   Tau[3] = 0.0;
   Tau[4] = 0.0;
+  for(i = 0; i < 5; ++i)
+  {
+    TrimmedP4[i].SetXYZT(0.0, 0.0, 0.0, 0.0);
+    PrunedP4[i].SetXYZT(0.0, 0.0, 0.0, 0.0);
+    SoftDroppedP4[i].SetXYZT(0.0, 0.0, 0.0, 0.0);
+  }
 }
 
@@ -225,4 +244,18 @@
   object.IsConstituent = IsConstituent;
   object.BTag = BTag;
+  object.BTagAlgo = BTagAlgo;
+  object.BTagDefault = BTagDefault;
+  object.BTagPhysics = BTagPhysics;
+  object.BTagNearest2 = BTagNearest2;
+  object.BTagNearest3 = BTagNearest3;
+  object.BTagHeaviest = BTagHeaviest;
+  object.BTagHighestPt = BTagHighestPt;
+  object.FlavorAlgo = FlavorAlgo;
+  object.FlavorDefault = FlavorDefault;
+  object.FlavorPhysics = FlavorPhysics;
+  object.FlavorNearest2 = FlavorNearest2;
+  object.FlavorNearest3 = FlavorNearest3;
+  object.FlavorHeaviest = FlavorHeaviest;
+  object.FlavorHighestPt = FlavorHighestPt;
   object.TauTag = TauTag;
   object.Eem = Eem;
@@ -249,4 +282,12 @@
   object.MeanSqDeltaR = MeanSqDeltaR;
   object.PTD = PTD;
+  object.Ntimes = Ntimes; 
+  object.IsolationVar = IsolationVar;
+  object.IsolationVarRhoCorr = IsolationVarRhoCorr;
+  object.SumPtCharged = SumPtCharged;
+  object.SumPtNeutral = SumPtNeutral;
+  object.SumPtChargedPU = SumPtChargedPU;
+  object.SumPt = SumPt;
+
   object.FracPt[0] = FracPt[0];
   object.FracPt[1] = FracPt[1];
@@ -259,7 +300,30 @@
   object.Tau[3] = Tau[3];
   object.Tau[4] = Tau[4];
+  
+  object.TrimmedP4[0] = TrimmedP4[0];
+  object.TrimmedP4[1] = TrimmedP4[1];
+  object.TrimmedP4[2] = TrimmedP4[2];
+  object.TrimmedP4[3] = TrimmedP4[3];
+  object.TrimmedP4[4] = TrimmedP4[4];
+  object.PrunedP4[0] = PrunedP4[0];
+  object.PrunedP4[1] = PrunedP4[1];
+  object.PrunedP4[2] = PrunedP4[2];
+  object.PrunedP4[3] = PrunedP4[3];
+  object.PrunedP4[4] = PrunedP4[4];
+  object.SoftDroppedP4[0] = SoftDroppedP4[0];
+  object.SoftDroppedP4[1] = SoftDroppedP4[1];
+  object.SoftDroppedP4[2] = SoftDroppedP4[2];
+  object.SoftDroppedP4[3] = SoftDroppedP4[3];
+  object.SoftDroppedP4[4] = SoftDroppedP4[4];
+
+  object.NSubJetsTrimmed = NSubJetsTrimmed;
+  object.NSubJetsPruned = NSubJetsPruned;
+  object.NSubJetsSoftDropped = NSubJetsSoftDropped;
 
   object.fFactory = fFactory;
   object.fArray = 0;
+
+  // Copy cluster timing info
+  copy(Ecal_E_t.begin(),Ecal_E_t.end(),back_inserter(object.Ecal_E_t));
 
   if(fArray && fArray->GetEntriesFast() > 0)
@@ -278,4 +342,5 @@
 void Candidate::Clear(Option_t* option)
 {
+  int i;
   SetUniqueID(0);
   ResetBit(kIsReferenced);
@@ -288,4 +353,18 @@
   IsConstituent = 0;
   BTag = 0;
+  BTagAlgo = 0;
+  BTagDefault = 0;
+  BTagPhysics = 0;
+  BTagNearest2 = 0;
+  BTagNearest3 = 0;
+  BTagHeaviest = 0;
+  BTagHighestPt = 0;
+  FlavorAlgo = 0;
+  FlavorDefault = 0;
+  FlavorPhysics = 0;
+  FlavorNearest2 = 0;
+  FlavorNearest3 = 0;
+  FlavorHeaviest = 0;
+  FlavorHighestPt = 0;
   TauTag = 0;
   Eem = 0.0;
@@ -311,4 +390,15 @@
   MeanSqDeltaR = 0.0;
   PTD = 0.0;
+  
+  Ntimes = 0;
+  Ecal_E_t.clear();
+  
+  IsolationVar = -999;
+  IsolationVarRhoCorr = -999;
+  SumPtCharged = -999;
+  SumPtNeutral = -999;
+  SumPtChargedPU = -999;
+  SumPt = -999;
+  
   FracPt[0] = 0.0;
   FracPt[1] = 0.0;
@@ -321,5 +411,16 @@
   Tau[3] = 0.0;
   Tau[4] = 0.0;
-
+  
+  for(i = 0; i < 5; ++i)
+  {
+    TrimmedP4[i].SetXYZT(0.0, 0.0, 0.0, 0.0);
+    PrunedP4[i].SetXYZT(0.0, 0.0, 0.0, 0.0); 
+    SoftDroppedP4[i].SetXYZT(0.0, 0.0, 0.0, 0.0);
+  }
+
+  NSubJetsTrimmed = 0;
+  NSubJetsPruned = 0;
+  NSubJetsSoftDropped = 0;
+  
   fArray = 0;
 }
Index: classes/DelphesClasses.h
===================================================================
--- classes/DelphesClasses.h	(revision f53a4d29acc13d296285ecd9b0a986c73a2c0efb)
+++ classes/DelphesClasses.h	(revision d38348d6fa05d814372b4af29ec82c9928ff5be9)
@@ -84,4 +84,15 @@
 //---------------------------------------------------------------------------
 
+class LHEFWeight: public TObject
+{
+public:
+  Int_t ID; // weight ID
+  Float_t Weight; // weight value
+
+  ClassDef(LHEFWeight, 1)
+};
+
+//---------------------------------------------------------------------------
+
 class HepMCEvent: public Event
 {
@@ -231,4 +242,13 @@
   TRefArray Particles; // references to generated particles
 
+  // Isolation variables
+
+  Float_t IsolationVar;
+  Float_t IsolationVarRhoCorr;
+  Float_t SumPtCharged;
+  Float_t SumPtNeutral;
+  Float_t SumPtChargedPU;
+  Float_t SumPt;
+
   static CompBase *fgCompare; //!
   const CompBase *GetCompare() const { return fgCompare; }
@@ -257,4 +277,13 @@
   TRef Particle; // reference to generated particle
 
+  // Isolation variables
+
+  Float_t IsolationVar;
+  Float_t IsolationVarRhoCorr;
+  Float_t SumPtCharged;
+  Float_t SumPtNeutral;
+  Float_t SumPtChargedPU;
+  Float_t SumPt;
+
   static CompBase *fgCompare; //!
   const CompBase *GetCompare() const { return fgCompare; }
@@ -281,4 +310,13 @@
   TRef Particle; // reference to generated particle
 
+   // Isolation variables
+
+  Float_t IsolationVar;
+  Float_t IsolationVarRhoCorr;
+  Float_t SumPtCharged;
+  Float_t SumPtNeutral;
+  Float_t SumPtChargedPU;
+  Float_t SumPt;
+
   static CompBase *fgCompare; //!
   const CompBase *GetCompare() const { return fgCompare; }
@@ -307,4 +345,21 @@
 
   UInt_t BTag; // 0 or 1 for a jet that has been tagged as containing a heavy quark
+
+  UInt_t BTagAlgo;
+  UInt_t BTagDefault;
+  UInt_t BTagPhysics;
+  UInt_t BTagNearest2;
+  UInt_t BTagNearest3;
+  UInt_t BTagHeaviest;
+  UInt_t BTagHighestPt;
+
+  UInt_t FlavorAlgo;
+  UInt_t FlavorDefault;
+  UInt_t FlavorPhysics;
+  UInt_t FlavorNearest2;
+  UInt_t FlavorNearest3;
+  UInt_t FlavorHeaviest;
+  UInt_t FlavorHighestPt;
+
   UInt_t TauTag; // 0 or 1 for a jet that has been tagged as a tau
 
@@ -313,17 +368,21 @@
   Float_t EhadOverEem; // ratio of the hadronic versus electromagnetic energy deposited in the calorimeter
 
-  Int_t    NCharged; // number of charged constituents 
-  Int_t    NNeutrals; // number of neutral constituents 
-  Float_t  Beta; // (sum pt of charged pile-up constituents)/(sum pt of charged constituents) 
-  Float_t  BetaStar; // (sum pt of charged constituents coming from hard interaction)/(sum pt of charged constituents) 
-  Float_t  MeanSqDeltaR; // average distance (squared) between constituent and jet weighted by pt (squared) of constituent
-  Float_t  PTD; // average pt between constituent and jet weighted by pt of constituent
-  Float_t  FracPt[5]; // (sum pt of constituents within a ring 0.1*i < DeltaR < 0.1*(i+1))/(sum pt of constituents) 
-
-  Float_t Tau1; // 1-subjettiness
-  Float_t Tau2; // 2-subjettiness
-  Float_t Tau3; // 3-subjettiness
-  Float_t Tau4; // 4-subjettiness
-  Float_t Tau5; // 5-subjettiness
+  Int_t NCharged; // number of charged constituents
+  Int_t NNeutrals; // number of neutral constituents
+  Float_t Beta; // (sum pt of charged pile-up constituents)/(sum pt of charged constituents)
+  Float_t BetaStar; // (sum pt of charged constituents coming from hard interaction)/(sum pt of charged constituents)
+  Float_t MeanSqDeltaR; // average distance (squared) between constituent and jet weighted by pt (squared) of constituent
+  Float_t PTD; // average pt between constituent and jet weighted by pt of constituent
+  Float_t FracPt[5]; // (sum pt of constituents within a ring 0.1*i < DeltaR < 0.1*(i+1))/(sum pt of constituents)
+
+  Float_t Tau[5]; // N-subjettiness
+
+  TLorentzVector TrimmedP4[5]; // first entry (i = 0) is the total Trimmed Jet 4-momenta and from i = 1 to 4 are the trimmed subjets 4-momenta
+  TLorentzVector PrunedP4[5]; // first entry (i = 0) is the total Pruned Jet 4-momenta and from i = 1 to 4 are the pruned subjets 4-momenta
+  TLorentzVector SoftDroppedP4[5]; // first entry (i = 0) is the total SoftDropped Jet 4-momenta and from i = 1 to 4 are the pruned subjets 4-momenta
+
+  Int_t NSubJetsTrimmed; // number of subjets trimmed
+  Int_t NSubJetsPruned; // number of subjets pruned
+  Int_t NSubJetsSoftDropped; // number of subjets soft-dropped
 
   TRefArray Constituents; // references to constituents
@@ -334,6 +393,7 @@
 
   TLorentzVector P4() const;
-
-  ClassDef(Jet, 2)
+  TLorentzVector Area;
+
+  ClassDef(Jet, 3)
 };
 
@@ -392,5 +452,6 @@
   Float_t E; // calorimeter tower energy
 
-  Float_t T; //particle arrival time of flight
+  Float_t T; // ecal deposit time, averaged by sqrt(EM energy) over all particles, not smeared
+  Int_t   Ntimes; // number of hits contributing to time measurement
 
   Float_t Eem; // calorimeter tower electromagnetic energy
@@ -452,7 +513,26 @@
 
   Int_t IsPU;
+  Int_t IsRecoPU;
+
   Int_t IsConstituent;
 
   UInt_t BTag;
+
+  UInt_t BTagAlgo;
+  UInt_t BTagDefault;
+  UInt_t BTagPhysics;
+  UInt_t BTagNearest2;
+  UInt_t BTagNearest3;
+  UInt_t BTagHeaviest;
+  UInt_t BTagHighestPt;
+
+  UInt_t FlavorAlgo;
+  UInt_t FlavorDefault;
+  UInt_t FlavorPhysics;
+  UInt_t FlavorNearest2;
+  UInt_t FlavorNearest3;
+  UInt_t FlavorHeaviest;
+  UInt_t FlavorHighestPt;
+
   UInt_t TauTag;
 
@@ -482,7 +562,32 @@
   Float_t  FracPt[5];
 
+  //Timing information
+
+  Int_t    Ntimes;
+  std::vector<std::pair<Float_t,Float_t> > Ecal_E_t;
+
+  // Isolation variables
+
+  Float_t IsolationVar;
+  Float_t IsolationVarRhoCorr;
+  Float_t SumPtCharged;
+  Float_t SumPtNeutral;
+  Float_t SumPtChargedPU;
+  Float_t SumPt;
+
   // N-subjettiness variables
 
   Float_t Tau[5];
+
+  // Other Substructure variables
+
+  TLorentzVector TrimmedP4[5]; // first entry (i = 0) is the total Trimmed Jet 4-momenta and from i = 1 to 4 are the trimmed subjets 4-momenta
+  TLorentzVector PrunedP4[5]; // first entry (i = 0) is the total Pruned Jet 4-momenta and from i = 1 to 4 are the pruned subjets 4-momenta
+  TLorentzVector SoftDroppedP4[5]; // first entry (i = 0) is the total SoftDropped Jet 4-momenta and from i = 1 to 4 are the pruned subjets 4-momenta
+
+  Int_t NSubJetsTrimmed; // number of subjets trimmed
+  Int_t NSubJetsPruned; // number of subjets pruned
+  Int_t NSubJetsSoftDropped; // number of subjets soft-dropped
+
 
   static CompBase *fgCompare; //!
@@ -504,5 +609,5 @@
   void SetFactory(DelphesFactory *factory) { fFactory = factory; }
 
-  ClassDef(Candidate, 2)
+  ClassDef(Candidate, 3)
 };
 
Index: classes/DelphesLHEFReader.cc
===================================================================
--- classes/DelphesLHEFReader.cc	(revision f53a4d29acc13d296285ecd9b0a986c73a2c0efb)
+++ classes/DelphesLHEFReader.cc	(revision d38348d6fa05d814372b4af29ec82c9928ff5be9)
@@ -82,5 +82,5 @@
   fEventCounter = -1;
   fParticleCounter = -1;
-  fRwgtList.clear();
+  fWeightList.clear();
 }
 
@@ -99,5 +99,5 @@
   TObjArray *partonOutputArray)
 {
-  int rc;
+  int rc, id;
   char *pch;
   double weight;
@@ -158,5 +158,5 @@
   else if(strstr(fBuffer, "<wgt"))
   {
-    pch = strstr(fBuffer, ">");
+    pch = strpbrk(fBuffer, "\"'");
     if(!pch)
     {
@@ -165,6 +165,16 @@
     }
 
-    DelphesStream bufferStream(pch + 1);
-    rc = bufferStream.ReadDbl(weight);
+    DelphesStream idStream(pch + 1);
+    rc = idStream.ReadInt(id);
+
+    pch = strchr(fBuffer, '>');
+    if(!pch)
+    {
+      cerr << "** ERROR: " << "invalid weight format" << endl;
+      return kFALSE;
+    }
+
+    DelphesStream weightStream(pch + 1);
+    rc = weightStream.ReadDbl(weight);
 
     if(!rc)
@@ -174,5 +184,5 @@
     }
 
-    fRwgtList.push_back(weight);
+    fWeightList.push_back(make_pair(id, weight));
   }
   else if(strstr(fBuffer, "</event>"))
@@ -206,14 +216,15 @@
 //---------------------------------------------------------------------------
 
-void DelphesLHEFReader::AnalyzeRwgt(ExRootTreeBranch *branch)
-{
-  Weight *element;
-  vector<double>::const_iterator itRwgtList;
-
-  for(itRwgtList = fRwgtList.begin(); itRwgtList != fRwgtList.end(); ++itRwgtList)
-  {
-    element = static_cast<Weight *>(branch->NewEntry());
-
-    element->Weight = *itRwgtList;
+void DelphesLHEFReader::AnalyzeWeight(ExRootTreeBranch *branch)
+{
+  LHEFWeight *element;
+  vector< pair< int, double > >::const_iterator itWeightList;
+
+  for(itWeightList = fWeightList.begin(); itWeightList != fWeightList.end(); ++itWeightList)
+  {
+    element = static_cast<LHEFWeight *>(branch->NewEntry());
+
+    element->ID = itWeightList->first;
+    element->Weight = itWeightList->second;
   }
 }
Index: classes/DelphesLHEFReader.h
===================================================================
--- classes/DelphesLHEFReader.h	(revision f53a4d29acc13d296285ecd9b0a986c73a2c0efb)
+++ classes/DelphesLHEFReader.h	(revision d38348d6fa05d814372b4af29ec82c9928ff5be9)
@@ -31,4 +31,5 @@
 
 #include <vector>
+#include <utility>
 
 class TObjArray;
@@ -58,5 +59,5 @@
     TStopwatch *readStopWatch, TStopwatch *procStopWatch);
 
-  void AnalyzeRwgt(ExRootTreeBranch *branch);
+  void AnalyzeWeight(ExRootTreeBranch *branch);
 
 private:
@@ -83,5 +84,5 @@
   double fPx, fPy, fPz, fE, fMass;
   
-  std::vector<double> fRwgtList;
+  std::vector< std::pair< int, double > > fWeightList;
 };
 
Index: doc/genMakefile.tcl
===================================================================
--- doc/genMakefile.tcl	(revision f53a4d29acc13d296285ecd9b0a986c73a2c0efb)
+++ doc/genMakefile.tcl	(revision d38348d6fa05d814372b4af29ec82c9928ff5be9)
@@ -283,5 +283,5 @@
 dictDeps {DISPLAY_DICT} {display/DisplayLinkDef.h}
 
-sourceDeps {DELPHES} {classes/*.cc} {modules/*.cc} {external/ExRootAnalysis/*.cc} {external/Hector/*.cc}
+sourceDeps {DELPHES} {classes/*.cc} {modules/*.cc} {external/ExRootAnalysis/*.cc} {external/Hector/*.cc} {external/PUPPI/*.cc}
 
 sourceDeps {FASTJET} {modules/FastJet*.cc} {external/fastjet/*.cc} {external/fastjet/tools/*.cc} {external/fastjet/plugins/*/*.cc} {external/fastjet/contribs/*/*.cc} 
Index: examples/Pythia8/configLHE.cmnd
===================================================================
--- examples/Pythia8/configLHE.cmnd	(revision d38348d6fa05d814372b4af29ec82c9928ff5be9)
+++ examples/Pythia8/configLHE.cmnd	(revision d38348d6fa05d814372b4af29ec82c9928ff5be9)
@@ -0,0 +1,18 @@
+! 1) Settings used in the main program.
+
+Main:numberOfEvents = 10         ! number of events to generate
+Main:timesAllowErrors = 3          ! how many aborts before run stops
+
+! 2) Settings related to output in init(), next() and stat().
+
+Init:showChangedSettings = on      ! list changed settings
+Init:showChangedParticleData = off ! list changed particle data
+Next:numberCount = 100             ! print message every n events
+Next:numberShowInfo = 1            ! print event information n times
+Next:numberShowProcess = 1         ! print process record n times
+Next:numberShowEvent = 0           ! print event record n times
+
+! 3) Set the input LHE file
+
+Beams:frameType = 4
+Beams:LHEF = examples/Pythia8/events.lhe    
Index: examples/Pythia8/configNoLHE.cmnd
===================================================================
--- examples/Pythia8/configNoLHE.cmnd	(revision d38348d6fa05d814372b4af29ec82c9928ff5be9)
+++ examples/Pythia8/configNoLHE.cmnd	(revision d38348d6fa05d814372b4af29ec82c9928ff5be9)
@@ -0,0 +1,34 @@
+! 1) Settings used in the main program.
+Main:numberOfEvents = 10         ! number of events to generate
+Main:timesAllowErrors = 3          ! how many aborts before run stops
+
+! 2) Settings related to output in init(), next() and stat().
+Init:showChangedSettings = on      ! list changed settings
+Init:showChangedParticleData = off ! list changed particle data
+Next:numberCount = 100             ! print message every n events
+Next:numberShowInfo = 1            ! print event information n times
+Next:numberShowProcess = 1         ! print process record n times
+Next:numberShowEvent = 0           ! print event record n times
+
+! 3) Beam parameter settings. Values below agree with default ones.
+Beams:idA = 2212                   ! first beam, p = 2212, pbar = -2212
+Beams:idB = 2212                   ! second beam, p = 2212, pbar = -2212
+Beams:eCM = 14000.                 ! CM energy of collision
+
+! 4) Settings for the hard-process generation.
+
+Top:gg2ttbar = on                  ! g g -> t tbar
+Top:qqbar2ttbar = on               ! q qbar -> t tbar
+
+! 5) Switch on/off the key event generation steps.
+#PartonLevel:MPI = off              ! no multiparton interactions
+#PartonLevel:ISR = off              ! no initial-state radiation
+#PartonLevel:FSR = off              ! no final-state radiation
+#HadronLevel:Hadronize = off        ! no hadronization
+#HadronLevel:Decay = off            ! no decays
+
+! 6) Other settings. Can be expanded as desired.
+#Tune:preferLHAPDF = off            ! use internal PDFs when LHAPDF not linked
+Tune:pp = 6                        ! use Tune 4Cx
+ParticleDecays:limitTau0 = on      ! set long-lived particle stable ...
+ParticleDecays:tau0Max = 10        ! ... if c*tau0 > 10 mm
Index: external/PUPPI/RecoObj.hh
===================================================================
--- external/PUPPI/RecoObj.hh	(revision d38348d6fa05d814372b4af29ec82c9928ff5be9)
+++ external/PUPPI/RecoObj.hh	(revision d38348d6fa05d814372b4af29ec82c9928ff5be9)
@@ -0,0 +1,33 @@
+#ifndef BACONANA_DATAFORMATS_RECOOBJ_HH
+#define BACONANA_DATAFORMATS_RECOOBJ_HH
+
+class RecoObj 
+{
+public:
+      RecoObj():
+	pt(0), eta(0), phi(0), m(0),
+	pfType(-1),vtxId(-1),
+	trkChi2(0),vtxChi2(0),
+	id(0),time(0),depth(0)
+    {}
+    ~RecoObj(){}
+    
+    float         pt, eta, phi, m;  // kinematics
+    int           pfType;
+    int           vtxId;               // Vertex Id from Vertex Collection
+    float         trkChi2;             // Track Chi2
+    float         vtxChi2;             // Vertex Chi2
+    int           id;
+    float         time,depth;    // Usefule Info
+    float         expProb;
+    float         expChi2PU;
+    float         expChi2;
+    float         dZ;
+    float         d0;
+};
+#endif
+
+// Only need 4-vector and ID
+// id = 0:   neutral
+// id = 1; charged from PV
+// id = 2; charged not from PV
Index: external/PUPPI/puppiAlgoBin.hh
===================================================================
--- external/PUPPI/puppiAlgoBin.hh	(revision d38348d6fa05d814372b4af29ec82c9928ff5be9)
+++ external/PUPPI/puppiAlgoBin.hh	(revision d38348d6fa05d814372b4af29ec82c9928ff5be9)
@@ -0,0 +1,125 @@
+#ifndef PUPPIALGOBIN_HH
+#define PUPPIALGOBIN_HH
+
+#include <iostream>
+#include <vector>
+#include <cmath>
+
+//...................... class to identify the puppi Algorithm parameters to be used                                                                                                       
+class puppiAlgoBin {
+
+ public :
+
+  puppiAlgoBin(){
+
+    fEtaMin_   = 0.;
+    fEtaMax_   = 0.;
+    fPtMin_    = 0.;
+    fConeSize_ = 0.;
+    fRMSPtMin_ = 0.;
+    fRMSScaleFactor_ = 1.0;
+    fNeutralMinE_    = 0.;
+    fNeutralPtSlope_ = 0.;
+    fApplyCHS_   = true;
+    fUseCharged_ = false ;
+    fApplyLowPUCorr_ = false;
+    fMetricId_ = 0;
+    fRMS_      = 0.;
+    fMean_     = 0.;
+    fMedian_   = 0.;
+  };
+
+  puppiAlgoBin(const float & etaMin,         const float & etaMax, const float & ptMin, const float & coneSize, const float & RMSPtMin,
+               const float & RMSScaleFactor, const float & neutralMinE, const float & neutralPtSlope,	                                     
+               const bool  & applyCHS,       const bool & useCharged, const bool & applyLowPUCorr, const int & metricId):
+    fEtaMin_(etaMin),
+    fEtaMax_(etaMax),
+    fPtMin_(ptMin),
+    fConeSize_(coneSize),
+    fRMSPtMin_(RMSPtMin),
+    fRMSScaleFactor_(RMSScaleFactor),
+    fNeutralMinE_(neutralMinE),
+    fNeutralPtSlope_(neutralPtSlope),
+    fApplyCHS_(applyCHS),
+    fUseCharged_(useCharged),
+    fApplyLowPUCorr_(applyLowPUCorr),
+    fMetricId_(metricId)
+  {
+    fRMS_    = 0.;
+    fMean_   = 0.;
+    fMedian_ = 0.;
+
+  };
+
+  virtual ~puppiAlgoBin(){};
+
+  bool operator == (const puppiAlgoBin & algo2) const {
+    if( fEtaMin_ == algo2.fEtaMin_ and 
+        fEtaMax_ == algo2.fEtaMax_ and 
+        fApplyCHS_ == algo2.fApplyCHS_ and 
+        fUseCharged_ == algo2.fUseCharged_ and 
+        fApplyLowPUCorr_ == algo2.fApplyLowPUCorr_ and 
+        fMetricId_ == algo2.fMetricId_ and 
+        fPtMin_ == algo2.fPtMin_ and 
+        fConeSize_ == algo2.fConeSize_ and 
+        fRMSPtMin_ == algo2.fRMSPtMin_ and 
+        fRMSScaleFactor_ == algo2.fRMSScaleFactor_ and 
+        fNeutralMinE_ == algo2.fNeutralMinE_ and 
+        fNeutralPtSlope_ == algo2.fNeutralPtSlope_ ) return true;
+    else return false;
+  };
+
+  void setPuppiParticles(const std::vector<puppiParticle> & puppiParticles){ // set the particles used by the current algorithm                                             
+    fPuppiParticlesPU_.clear();
+    fPuppiParticlesPV_.clear();
+    fPuppiParticlesNULL_.clear();
+  
+    for(size_t iPart = 0; iPart < puppiParticles.size(); iPart++){ // loop on the puppiParticles                            
+      if(puppiParticles.at(iPart).fPval_ == -999){ // default PVal
+        fPuppiParticlesNULL_.push_back(puppiParticles.at(iPart));        
+        continue ; 
+      }
+                                                 
+      if(puppiParticles.at(iPart).fPt_ <  fRMSPtMin_){  // should be discarded in the RMS computation
+        fPuppiParticlesNULL_.push_back(puppiParticles.at(iPart)); 
+        continue ; 
+      }
+     
+      if(puppiParticles.at(iPart).fPt_ < fPtMin_){ // under the chosen pt cut
+        fPuppiParticlesNULL_.push_back(puppiParticles.at(iPart)); 
+        continue ; 
+      }
+
+      // zero are neutral particle, 1 LV charged, 2PU      
+      if(fUseCharged_ && (fabs(puppiParticles.at(iPart).fParticleId_) >=0 && fabs(puppiParticles.at(iPart).fParticleId_) <=1)) fPuppiParticlesPV_.push_back(puppiParticles.at(iPart));
+      if(fUseCharged_ && fabs(puppiParticles.at(iPart).fParticleId_) < 2) continue;
+      fPuppiParticlesPU_.push_back(puppiParticles.at(iPart));
+    }
+  };
+
+  float fEtaMin_;
+  float fEtaMax_;
+  float fPtMin_ ;
+  float fConeSize_;
+  float fRMSPtMin_;
+  float fRMSScaleFactor_;
+  float fNeutralMinE_;
+  float fNeutralPtSlope_;
+
+  bool  fApplyCHS_;
+  bool  fUseCharged_;
+  bool  fApplyLowPUCorr_;
+
+  int   fMetricId_;
+
+  float fRMS_;
+  float fMean_;
+  float fMedian_;
+
+  std::vector<puppiParticle> fPuppiParticlesPU_;
+  std::vector<puppiParticle> fPuppiParticlesPV_;
+  std::vector<puppiParticle> fPuppiParticlesNULL_;
+
+};
+
+#endif
